KNIFE-DOWNLOAD(1)

NAME
knife-download - The man page for the knife download subcommand.

The knife download subcommand is used to download roles, cookbooks, environments, nodes, and data bags from the Chef server to the current working directory. It can be used to back up data on the Chef server, inspect the state of one or more files, or to extract out-of-process changes users may have made to files on the Chef server, such as if a user made a change that bypassed version source control. This subcommand is often used in conjunction with knife diff, which can be used to see exactly what changes will be downloaded, and then knife upload, which does the opposite of knife download.

Syntax

This subcommand has the following syntax:

$ knife download [PATTERN...] (options)

Options

This subcommand has the following options:

-c CONFIG_FILE, --config CONFIG_FILE
    The configuration file to use.

--chef-repo-path PATH
    The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by chef_repo_path in config.rb.

--chef-zero-port PORT
    The port on which chef-zero will listen.

--[no-]color
    Use to view colored output.

--concurrency
    The number of allowed concurrent connections. Default: 10.

--cookbook-version VERSION
    The version of a cookbook to be downloaded.

-d, --disable-editing
    Use to prevent the $EDITOR from being opened and to accept data as-is.

--defaults
    Use to have knife use the default value instead of asking a user to provide one.

--[no-]diff
    Use to download only new and modified files. Set to false to download all files. Default: --diff.

-e EDITOR, --editor EDITOR
    The $EDITOR that is used for all interactive commands.

-E ENVIRONMENT, --environment ENVIRONMENT
    The name of the environment. When this option is added to a command, the command will run only against the named environment.

-F FORMAT, --format FORMAT
    The output format: summary (default), text, json, yaml, and pp.

--[no-]force
    Use --force to download files even when the file on the hard drive is identical to the object on the server (role, cookbook, etc.). By default, files are compared to see if they have equivalent content, and local files are only overwritten if they are different. Default: --no-force.

-h, --help
    Shows help for the command.

-k KEY, --key KEY
    The private key that knife will use to sign requests made by the API client to the Chef server.

-n, --dry-run
    Use to take no action and only print out results. Default: false.

--print-after
    Use to show data after a destructive operation.

--[no-]purge
    Use --purge to delete local files and directories that do not exist on the Chef server. By default, if a role, cookbook, etc. does not exist on the Chef server, the local file for said role will be left alone and NOT deleted. Default: --no-purge.

--[no-]recurse
    Use --no-recurse to disable downloading a directory recursively. Default: --recurse.

--repo-mode MODE
    The layout of the local chef-repo. Possible values: static, everything, or hosted_everything. Use static for just roles, environments, cookbooks, and data bags. By default, everything and hosted_everything are dynamically selected depending on the server type. Default: everything / hosted_everything.

-s URL, --server-url URL
    The URL for the Chef server.

-u USER, --user USER
    The user name used by knife to sign requests made by the API client to the Chef server. Authentication will fail if the user name does not match the private key.

-v, --version
    The version of the chef-client.

-V, --verbose
    Set for more verbose outputs. Use -VV for maximum verbosity.

-y, --yes
    Use to respond to all confirmation prompts with "Yes". knife will not ask for confirmation.

-z, --local-mode
    Use to run the chef-client in local mode. This allows all commands that work against the Chef server to also work against the local chef-repo.

    Examples

    To download the entire chef-repo from the Chef server, browse to the top level of the chef-repo and enter:

    $ knife download /

    To download the cookbooks/ directory from the Chef server, browse to the top level of the chef-repo and enter:

    $ knife download cookbooks

    or from anywhere in the chef-repo, enter:

    $ knife download /cookbooks

    To download the environments/ directory from the Chef server, browse to the top level of the chef-repo and enter:

    $ knife download environments

    or from anywhere in the chef-repo, enter:

    $ knife download /environments

    To download an environment named "production" from the Chef server, browse to the top level of the chef-repo and enter:

    $ knife download environments/production.json

    or from the environments/ directory, enter:

    $ knife download production.json

    To download the roles/ directory from the Chef server, browse to the top level of the chef-repo and enter:

    $ knife download roles

    or from anywhere in the chef-repo, enter:

    $ knife download /roles

    To download all cookbooks that start with "apache" and belong to the "webserver" role, browse to the top level of the chef-repo and enter:

    $  knife download cookbooks/apache\* roles/webserver.json

AUTHOR
Chef